/* Copyright (C) 2005, University of Massachusetts, Multi-Agent Systems Lab
 * See LICENSE for license information
 */

package utilities.cfg;

import java.io.*;
import java.util.*;

import utilities.*;

public class CfgTest
{

    public static void main(String args[])
    {
        String configfile;
        configfile = "test.cfg";
        CfgManager manager = new CfgManager(configfile);
        
        GraphNode test = new GraphNode("test");
        manager.addConfiguredObject(test, "/graphnodes/test");
        System.err.println("adding the GraphNode 'test' to configuration.");
        System.err.println("test is " + test + ".");
        
        System.err.println("file " + configfile + " read in.");
        System.err.println("query for '/' returns: " + manager.get("/"));
        System.err.println("query for '/locales/bedroom/name' returns: " +
                manager.get("/locales/bedroom/name"));
        
        System.err.println("loading GraphNode 'test2' with the settings from" +
                " 'test'.");
        GraphNode test2 = new GraphNode("test2");
        manager.removeConfiguredObject(test);
        manager.addConfiguredObject(test2, "/graphnodes/test");
        
        System.err.println("test2 is " + test2 + ".");
        
        System.err.println("saving to " + configfile + ".2");
        manager.setFileName(configfile + ".2");
        manager.save();
    }
}

